/*
 ****************************
 *       Preferences        *
 *    by widgetschmie.de    *
 ****************************
 */


function showPrefs() {
	if(iButtonBlocked())
		return;
	
	var front = getObj("front");
	var back = getObj("back");
	
	// if (null != originalAccounts) allAccounts = originalAccounts;	
	
	if(allAccounts && allAccounts[0]) {
		for (i = 0; i < allAccounts[0].length; i++)
		{
			if (allAccounts[0][i].kind != "FTP") allAccounts[0].splice(i--, 1);
		}
	}
	
	showVersion(_version);		// sets version-number
	
	if(window.widget) {
		window.resizeTo(FRONT_WIDTH, 280);
		widget.prepareForTransition("ToBack");
	}
	
	removeAllFrontAccounts();
	front.style.display = "none";
	back.style.display = "block";
	prefsShown = true;
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}


// adjusts the prefs and sets important variables
function adjustPrefs() {
	loadAccounts();
	if(window.widget) FTPUploadPlugin.setWidgetVisible(true);
	_widgetIsVisible = true;
	
	loadSoundDropdown();
	
	if(window.widget) {
		FTPUploadPlugin.setCanSendToSelf(SEND_TO_SELF);
		
		// upload sound
		if(!getObj("currentAlertSoundEmbed")) {
			var opt = getObj("uploadSound");
			var optval = opt.options[opt.selectedIndex].value;
			
			if("System Alarm Sound" != optval && '' != optval) {
				var soundPlayer = document.createElement("embed");
				soundPlayer.setAttribute("id", "currentAlertSoundEmbed");
				soundPlayer.setAttribute("src", optval);
				soundPlayer.setAttribute("autostart", "false");
				soundPlayer.setAttribute("hidden", "true");
				soundPlayer.setAttribute("enablejavascript", true);
				getObj("soundPlayerDiv").appendChild(soundPlayer);
			}
		}
		
		// spring-loaded delay
		var springDelaySelector = getObj('springDelay');
		springFolderDelay = widget.preferenceForKey('springFolderDelay') ? widget.preferenceForKey('springFolderDelay') : springFolderDelay;
		if(isNaN(springFolderDelay))
			springFolderDelay = 3;
		selectValue(springDelaySelector, springFolderDelay);
		
		// bonjour Download
		var enableBJ = widget.preferenceForKey('enableBonjourSend');
		if ("1" == enableBJ)
		{
			getObj('enableBonjourSend').checked = true;
			FTPUploadPlugin.setEnableBounjourSend(enableBJ);
		}
		bonjourActivationToggled();

		var askAcceptEachTransfer = widget.preferenceForKey('bonjourAskReceive');
		askAcceptEachTransfer = ("0" != askAcceptEachTransfer);						// catches "1" and undefined
		getObj('bonjourAskReceive').checked = askAcceptEachTransfer;
		FTPUploadPlugin.setAskToAcceptIncomingTransfer(askAcceptEachTransfer);
		
		
		// Bonjour compression
		bonjourCompressionMethod = widget.preferenceForKey('bonjourCompressionMethod') ? widget.preferenceForKey('bonjourCompressionMethod') : bonjourCompressionMethod;
		var valid_methods = new Array('none', 'always', 'ask', 'smart');
		bonjourCompressionMethod = inArray(bonjourCompressionMethod, valid_methods) ? bonjourCompressionMethod : 'smart';
		selectValue(getObj('bonjourCompressionMethod'), bonjourCompressionMethod);
		bonjourCompressionMethodChanged();
		
		
		// adjust the download target
		var dlTarget = widget.preferenceForKey('bonjourDownloadTarget');
		if (null != dlTarget)
		{
			selectValue(getObj('bonjourDownloadTarget'), dlTarget);
			FTPUploadPlugin.setBonjourDownloadTarget(dlTarget);
		}
		
		
		// bonjour subfolders (modes: none, sender, date, senderAndDate)
		bonjourSubfolderMode = widget.preferenceForKey('bonjourSubfolderMode');
		
		if(("sender" == bonjourSubfolderMode) || ("senderAndDate" == bonjourSubfolderMode) || (undefined == bonjourSubfolderMode)) {
			getObj('createFolderBySender').checked = true;
			var createFbS = true;
		}
		else {
			getObj('createFolderBySender').checked = false;
			var createFbS = false;
		}
		
		// bonjour subfolder per sender and date
		if(("date" == bonjourSubfolderMode) || ("senderAndDate" == bonjourSubfolderMode)) {
			getObj('createFolderByDate').checked = true;
			var createFbD = true;
		}
		else {
			getObj('createFolderByDate').checked = false;
			var createFbD = false;
		}
		
		FTPUploadPlugin.setCreateFolderBySender(createFbS);
		FTPUploadPlugin.setCreateFolderByDate(createFbD);
		
		// BlueTooth
		enableBluetooth = widget.preferenceForKey('enableBluetooth');
		getObj('enableBluetooth').checked = enableBluetooth ? true : false;
		if(enableBluetooth) {
			//FTPUploadPlugin.setEnableBluetooth(enableBT);
		}
	}
	
	toggleDisabledIfChecked('enableBonjourSend', 'bonjourAskReceive');
}


function savePrefs() {
	var prefform = getObj('prefform');
		
	// save all
	if(window.widget) {
		saveAccounts();
		
		// spring-loaded delay
		var springDelaySelector = getObj('springDelay')
		springFolderDelay = springDelaySelector.options[springDelaySelector.selectedIndex].value;
		if(isNaN(springFolderDelay))
			springFolderDelay = 3;
		widget.setPreferenceForKey(springFolderDelay, 'springFolderDelay');
		
		
		// enable bonjour
		var enableBJ = getObj('enableBonjourSend').checked ? "1" : "0";
		widget.setPreferenceForKey(enableBJ, "enableBonjourSend");
		FTPUploadPlugin.setEnableBounjourSend(enableBJ);
		
		
		// compression
		var valid_methods = new Array('none', 'always', 'ask', 'smart');
		var compressionMethodSelector = getObj('bonjourCompressionMethod');
		var method = compressionMethodSelector.options[compressionMethodSelector.selectedIndex].value;
		bonjourCompressionMethod = inArray(method, valid_methods) ? method : 'smart';
		widget.setPreferenceForKey(bonjourCompressionMethod, "bonjourCompressionMethod");
		
		
		// ask to accept transfers
		var askAcceptEachTransfer = getObj('bonjourAskReceive').checked ? "1" : "0";
		widget.setPreferenceForKey(askAcceptEachTransfer, "bonjourAskReceive");
		FTPUploadPlugin.setAskToAcceptIncomingTransfer("1" == askAcceptEachTransfer);
		
		
		// Bonjour target destination
		if (enableBJ)
		{
			var dlTarget = widget.preferenceForKey('bonjourDownloadTarget');
			if (null != dlTarget)
			{
				FTPUploadPlugin.setBonjourDownloadTarget(dlTarget);
			}
		}
		
		// bonjour subfolders (modes: none, sender, date, senderAndDate)
		var createFbS = getObj('createFolderBySender').checked ? true : false;
		var createFbD = getObj('createFolderByDate').checked ? true : false;
		
		bonjourSubfolderMode = createFbS ? (createFbD ? "senderAndDate" : "sender") : (createFbD ? "date" : "none");
		widget.setPreferenceForKey(bonjourSubfolderMode, "bonjourSubfolderMode");
		FTPUploadPlugin.setCreateFolderBySender(createFbS);
		FTPUploadPlugin.setCreateFolderByDate(createFbD);
		
		// Bluetooth
		enableBluetooth = getObj('enableBluetooth').checked ? true : false;
		widget.setPreferenceForKey(enableBluetooth, 'enableBluetooth');
	}
	
	hidePrefs();
}


function hidePrefs() {
	var front = getObj("front");
	var back = getObj("back");
	hideError();
	if(window.widget && !FTPUploadPlugin.uploadInProgress())
		updateIdleStatus(true);
	
	if(window.widget) {
		widget.prepareForTransition("ToFront");
		window.resizeTo(FRONT_WIDTH, FRONT_HEIGHT);
	}
	
	front.style.display = "block";
	back.style.display = "none";
	prefsShown = false;
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}


// loads the sound-dropdown-menu
function loadSoundDropdown() {
	var selector = getObj('uploadSound');
	
	if(window.widget) {
		var alarmSound = widget.preferenceForKey("uploadSound");
		var soundsarr = new Array("System Alarm Sound");
		var validSounds = FTPUploadPlugin.validSounds();
		var sounds = mergeArrays(soundsarr, validSounds);
		var currentLibrary = 0;
		
		var hasNewOptions = has1043Features();
		
		//<option value="System Alarm Sound">System alarm sound</option>
		
		// add sounds to the drop-down
		for(i = 0; i < sounds.length; i++) {
			var components = sounds[i].split("/");
			
			// new library; add separator
			var separator;
			if(currentLibrary != components[1]) {
				if(hasNewOptions)
					separator = document.createElement("hr");
				else {
					separator = document.createElement("option");
					separator.value = '';
					separator.innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
				}
				selector.appendChild(separator);
			}
			
			// add new sound-option
			var soundname = (components.length > 1) ? components[components.length - 1] : components[0];
			soundname = soundname.substring(0, (soundname.indexOf(".") > -1) ? soundname.indexOf(".", soundname.length - 6) : soundname.length);
			
			var newoption = document.createElement("option");
			newoption.value = sounds[i];
			newoption.innerHTML = (soundname.length > 0) ? soundname : "System Sound";
			newoption.selected = (sounds[i] == alarmSound);
			selector.appendChild(newoption);
			
			currentLibrary = components[1];
		}
		
		// hide the play-button if no sound is chosen
		if('' == alarmSound) {
			try {
				getObj('uploadSoundPlayNow').style.display = 'none';
			}
			catch(exc) {  }
		}
	}
	else {
		selector.disabled = true;
	}
}


// Eyecandy if the user (un)checks the bonjour-receive-option
function bonjourActivationToggled() {
	toggleDisabledIfChecked('enableBonjourSend', 'bonjourAskReceive');
	toggleDisabledIfChecked('enableBonjourSend', 'bonjourDownloadTargetLabel');
	toggleDisabledIfChecked('enableBonjourSend', 'bonjourDownloadTarget');
	toggleDisabledIfChecked('enableBonjourSend', 'createFolderBySender');
	toggleDisabledIfChecked('enableBonjourSend', 'createFolderByDate');
}

//
function bonjourCompressionMethodChanged() {
	var selector = getObj('bonjourCompressionMethod');
	var show = ('smart' == selector.options[selector.selectedIndex].value);
	try {
		getObj('smartCompressionHint').style.display = show ? "block" : "none";
	}
	catch(exc) {  }
}


function switchPrefTab(tab)
{
	var found = false;
	var thedivs = _sections ? _sections : new Array();
	
	for(var i = 0; i < thedivs.length; i++) {
		if(tab == thedivs[i]) {
			getObj("tab_" + thedivs[i]).setAttribute("class", "tabitem selected");
			getObj("prefs_" + thedivs[i]).style.display = "block";
			found = true;
		}
		else {
			getObj("tab_" + thedivs[i]).setAttribute("class", "tabitem");
			getObj("prefs_" + thedivs[i]).style.display = "none";
		}
	}
	
	if(!found) {
		getObj("prefs_about").style.display = "block";
	}
}

// switches to the account-tab (used in most errordialogues)
function switchToAccountPrefs() {
	switchPrefTab('accounts');
	showPrefs();
}

// switches to the Bonjour Help Text
function switchToBonjourHelp() {
	switchPrefTab('about');
	scrollDivTo('helpdiv', 'bonjour_help');
}

// switches to the Bluetooth Help Text
function switchToBluetoothHelp() {
	switchPrefTab('about');
	scrollDivTo('helpdiv', 'bluetooth_help');
}

function scrollDivTo(div, anchor) {
	var div = getObj(div);
	var anchor = getObj(anchor);
	if(div && anchor) {
		div.scrollTop = anchor.offsetTop;
	}
}


// switches tabs. Structure must be <tab> inside <tabbar> inside <parent>, all DIV elements
//	The tabs must have the class "subtab". The tab-sections must be childs of <parent> with the class "subtab_section"
function switchSubTab(tab, show) {
	var tab = getObj(tab);
	var tabbar = tab.parentNode;
	var parent = tabbar.parentNode;
	var all_tabs = tabbar.childNodes;
	var all_divs = parent.childNodes;
	
	// select right tab
	for(var i = 0; i < all_tabs.length; i++) {
		var this_tab = all_tabs[i];
		if('div' == this_tab.nodeName.toLowerCase() && this_tab.hasAttribute('class') && this_tab.getAttribute('class').indexOf("subtab") > -1) {
			if(tab == this_tab)
				this_tab.setAttribute('class', "subtab subtab_active");
			else
				this_tab.setAttribute('class', "subtab");
		}
	}
	
	// display the tab content
	for(var i = 0; i < all_divs.length; i++) {
		var this_div = all_divs[i];
		if('div' == this_div.nodeName.toLowerCase() && this_div.hasAttribute('class') && this_div.getAttribute('class').indexOf("subtab_section") > -1) {
			if(getObj(show) == this_div)
				this_div.setAttribute('class', "subtab_section subtab_section_shown");
			else
				this_div.setAttribute('class', "subtab_section");
		}
	}
}



// sheet animation

var sheetAnim = { obj:null, start:null, stop:null, time:300, to:0, size:0 }
function showSheet(id)
{
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	// set animation-variables
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = parseInt(document.defaultView.getComputedStyle(obj, null).getPropertyValue('height')) + 10;
	
	if(sheetAnim.to != sheetAnim.size)
		setTimeout("animateSheet();", 10);
}

function animateSheet()
{
	var now = (new Date()).getTime();
	if (now < sheetAnim.stop)
	{
		var delta = (now - sheetAnim.start) / sheetAnim.time;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (sheetAnim.to < 1) ? (sheetAnim.size - (sheetAnim.size * factor)) : (sheetAnim.to * factor);

		sheetAnim.obj.style.height = size + "px";
		
		setTimeout("animateSheet();", 10);
	} else {
		sheetAnim.obj.style.height = sheetAnim.to + "px";
		sheetAnim.size = sheetAnim.to;
		sheetAnim.obj = null;
	}
}

function hideSheet(id)
{
	if(sheetAnim.to == 0) return;
	
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = 0;
	setTimeout("animateSheet();", 10);
}



function loadAccounts()
{
	var loadedAcc;
	if(window.widget)
		loadedAcc = widget.preferenceForKey("Accounts");
	if (!loadedAcc) return;
	
	var accounts = Deserialize(loadedAcc);
	
	for (i = 0; i < accounts.length; i++)
	{
		var tmp = accounts[i];
		var host = tmp["host"];
		var notation = tmp["notation"];
		var path = tmp["path"];
		var httppath = tmp["httppath"];
		var user = (tmp["user"] ? tmp["user"] : "");
		var pass = "";
		
		if ((host.length > 4) && (user == ""))
		{
			var result = FTPUploadPlugin.authorizationForHost(host);
			if (result.length == 2)
			{
				user = result[0];
				pass = result[1];
			}
		}
		if ((host.length > 4) && (user != ""))
		{
			var result = FTPUploadPlugin.authorizationForHostAndUsername(""+host, user);
			if (result != "")
			{
				pass = result;
			}
		}
		

		allAccounts[0].push(new Account(notation, user, host, path, httppath, pass, "FTP"));
	}
}

function saveAccounts()
{
	var saveAcc = new Array();
	for (i = 0; i < allAccounts[0].length; i++)
	{
		var acc = allAccounts[0][i];
		var tempAcc = new Object();
		tempAcc["notation"] = acc.notation;
		tempAcc["host"] = acc.host;
		tempAcc["user"] = acc.username;
		tempAcc["path"] = acc.path;
		tempAcc["httppath"] = acc.httppath;
		saveAcc.push(tempAcc);
	}
	if(window.widget) {
		widget.setPreferenceForKey(Serialize(saveAcc), "Accounts");
	}
}


function newFTPAccount()
{
	var opt = getObj("newFTPAccountChooser");
	var optval = opt.options[opt.selectedIndex].value;
	
	if (optval == "") return; // seperator chosen. duh.
	
	showAccountForm();
	if ("@manual" == optval) return;
	
	var comps = optval.split(" ");
	var host;
	var user = "";
	if (comps.length > 1)
	{
		host = comps.slice(0, 1);
		var usertemp = (comps.slice(1)).join(" ");
		user = usertemp.substr(1, usertemp.length-2);
	} else {
		host = optval;
	}
	
	var form = document.forms['prefform'];
	form.acc_notation.value = optval;
	form.acc_host.value = host;
	form.acc_user.value = user;
	
	findPass(host, user);	
	form.acc_notation.focus();
	
	getObj("newFTPAccountChooser").selectedIndex = -1;
}

// Account saving
var loadedAccount = null;

function showAccountForm() {
	var form = document.forms['prefform'];
	if(loadedAccount) {
		form.acc_notation.value = loadedAccount.notation;
		form.acc_user.value = loadedAccount.username;
		form.acc_pass.value = loadedAccount.pass == "" ? "" : '********';
		form.acc_host.value = loadedAccount.host;
		form.acc_path.value = loadedAccount.path;
		form.acc_httppath.value = loadedAccount.httppath;
		
		// notification in the Path-tab
		var tab = getObj('accountFormTab2');
		if(tab) {
			tab.innerHTML = (loadedAccount.path || loadedAccount.httppath) ? "Path&nbsp;&nbsp;✔" : "Path";
		}
	}
	form.acc_notation.focus();
	
	switchSubTab(getObj("accountFormTab1"), "accountFormBasicInfo");
	showSheet("accountFormInner");
}

function saveAccount() {
	if(loadedAccount) {					// an existing account was altered, save the new values
		loadedAccount.saveNewValues();
	}
	else {								// save a new account
		var form = document.forms['prefform'];
		allAccounts[0].push(new Account(form.acc_notation.value, form.acc_user.value, form.acc_host.value, form.acc_path.value, form.acc_httppath.value, form.acc_pass.value, "FTP"));
	}
	hideAccountForm();
}

function hideAccountForm() {
	// hide it
	hideSheet("accountFormInner");
	
	// clean it up
	var form = document.forms['prefform'];
	form.acc_notation.value = '';
	form.acc_user.value = '';
	form.acc_pass.value = '';
	form.acc_host.value = '';
	form.acc_path.value = '';
	form.acc_httppath.value = '';
	loadedAccount = null;
}


