/*
 ******************************
 *         Übertragen         *
 *            © by            *
 *       Widgetschmie.de      *
 *         2006 - 2007        *
 ******************************
 */


/*
 * Define some globals and start
 */
var _version;
var _sections = new Array("options", "accounts", "bonjour", "about");		// define all possible prefsections here
var _widgetIsVisible;
var accountsShowingOnFront = false;
var prefsShown = false;
var uploadAccount;
var uploadFiles;
var activeUploadAccount;

var hoversOverAccount = false;
var hoversOverWidget = false;
var hoverCheckTimeout;
var iButtonBlockArr = new Array();
var poofImage;


var percentGauge = { centerX:46, centerY:43, radius:34, min:0, max:1, current:0, animation:{ from:0, to:0}, id:"percentGauge", canvas:null, parent:"percentGaugeBackground" };
var kbsGauge = { centerX:46, centerY:43, radius:34, min:0, max:6, current:0, animation:{ from:0, to:0}, id:"kbsGauge", canvas:null, parent:"speedGaugeBackground" };
var percentGaugeAnim = { startTime:0, stopTime:0, startValue:0, stopValue:0, animTime:600, timeout:null };
var kbsGaugeAnim = { startTime:0, stopTime:0, startValue:0, stopValue:0, animTime:600, timeout:null };
var currentPercent;
var uploadCancelled = false;

var pointerImage;
var pointerBullImage;
var fileUploadSmallIconSize = 24;
var fileUploadBigIconSize = 48;
//var nextUploadFile;
var speedGaugeShowsKBs;
var isFTPUpload;
var isBonjourUpload;
var isBluetoothUpload;
var uri;

var bonjourCompressionMethod = "smart";		// valid options: none, always, ask, smart
var thisTransferCompressed;
var bonjourSubfolderMode;
var enableBluetooth = false;

var initiateListingTimer;
var lastIdleScanTime = 1;						// time (in ms) of last scan
var originalAccounts;
var Springloaded_FlashCounter;
var acceptSpringLoadedHover;

var allAccounts = new Array(new Array());
var hoverAccount;
var currentHoverIndex = 0;
var oldHoverIndex = -1;
var springFolderDelay = 3;
var browsingBluetooth = false;

var FRONT_WIDTH = 300;
var FRONT_HEIGHT = 240;
var FRONT_MIDI_WIDTH = 270;
var FRONT_MIDI_HEIGHT = 200;
var FRONT_MINI_WIDTH = 200;
var FRONT_MINI_HEIGHT = 160;

var FTP_TIMEOUT = 15000;
var FADE_ANIM_TIME = 400;					// used by the object in/out fading
var ACCOUNT_ANIM_TIME = 400;				// used for the account-animation
var AUTO_CHANGE_STATUS_AFTER = 6000;		// time in ms after which the statusmessage disappears, a re-check of the status gets repeated and the copy-button disappears

var SEND_TO_SELF = true;


function init()
{
	createGenericButton(getObj("done"), "done", savePrefs);
	createGenericButton(getObj("errorDivCancelButton"), "Cancel", hideError);
	createGenericButton(getObj("errorDivOKButton"), "OK", hideError);
	
	switchPrefTab("options");
	_version = getCurrentVersion();
	
	// **********
	// preload Images
	pointerImage = new Image(68, 68);
	//pointerImage.src = 'Images/pointer.pdf';
	pointerImage.src = 'Images/pointer.tiff';
	pointerBullImage = new Image(68, 68);
	pointerBullImage.src = 'Images/pointer_bull.png';
	
	poofImage = new Image();
	poofImage.src = "/System/Library/CoreServices/Dock.app/Contents/Resources/poof.png";
	
	// digits
	for (i = 0; i < 10; i++)
	{
		var img = document.createElement("img");
		img.src = "Images/Digits/"+i+".png";
	}
	var img =  document.createElement("img");
	img.src = "Images/Digits/trans.png";
	img =  document.createElement("img");
	img.src = "Images/Digits/%.png";
	
	// progress
	for(i = 0; i < 12; i++) {
		var img = new Image();
		img.src = "Images/whiteProgress" + i + ".png";
	}
	
	// scrollhoverbars (hoverimages)
	img = document.createElement("img");		img.src = "Images/arrow.scrollDown.hover.png";
	img = document.createElement("img");		img.src = "Images/arrow.scrollUp.hover.png";
	
	
	// **********
	// Setup
	speedGaugeShowsKBs = true;
	makeGauge(percentGauge);
	makeGauge(kbsGauge);
	
	// **********
	// setup the prefs
	adjustPrefs();
	originalAccounts = null;
	
	// get FTP accounts from the keychain
	var ftpAccounts;
	if (window.widget)
	{
		ftpAccounts = FTPUploadPlugin.namesOfKeychainFTPAccounts();
		
		if (ftpAccounts.length > 0)
		{
			var selector = getObj('newFTPAccountChooser');
			var separator;
		
			if (has1043Features()) separator = document.createElement("hr");
			else {
				separator = document.createElement("option");
				separator.value = '';
				separator.innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
			}
			selector.appendChild(separator);
			
			for (i = 0; i < ftpAccounts.length; i++)
			{
				var thisAccount = ftpAccounts[i];
				var element = document.createElement("option");
				element.value = thisAccount;
				element.innerHTML = thisAccount;
				selector.appendChild(element);
			}
		}
	}
	//getObj("newFTPAccountChooser").selectedIndex = 0;
	
	
	// **********
	// status plus event handlers
	displayStatus('drop_files');
	setTimeout("updateIdleStatus()", 10);
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
	}
	
	
	/* DEBUG
	fadeElements(0, 1, new Array('percentGaugeBackground', 'speedGaugeBackground', 'percentGaugeGlass', 'speedGaugeGlass', 'cancelButton'));
	prepareGUIForTransfer();
	drawGauge(percentGauge, 0);
	drawGauge(kbsGauge, 0);
	setTimeout("animateKBSGauge(2.5)", 40);
	setTimeout("animateKBSGauge(5)", 2000);
	setTimeout("animateKBSGauge(1.5)", 4000);
	setTimeout("animateKBSGauge(2)", 6000);
	setTimeout("animateKBSGauge(4)", 8000);
	setTimeout("animatePercentGauge(0.52)", 40);
	setTimeout("displayPercent(52)", 40);
	setTimeout("displaySpeed(2.5)", 40);
	setTimeout("displaySpeed(5)", 2000);
	setTimeout("displaySpeed(1.5)", 4000);
	setTimeout("displaySpeed(2)", 6000);
	setTimeout("displaySpeed(4)", 8000);
	
	SEND_TO_SELF = true;
	//*/
}


function makeGauge(gauge)
{
	var canv = document.createElement('canvas');
	canv.setAttribute('class', 'gauge');
	var rad = gauge.radius;
	canv.style.height = (rad * 2)+"px";
	canv.style.width = (rad * 2)+"px";
	canv.style.top = (gauge.centerY - rad)+"px";
	canv.style.left = (gauge.centerX - rad)+"px";
	canv.setAttribute('id', gauge.id);
	canv.setAttribute('width', (rad * 2));
	canv.setAttribute('height', (rad * 2));
	
	// the bull
	var bull = document.createElement('img');
	bull.setAttribute('class', 'gaugeBull');
	bull.src = pointerBullImage.src;
	bull.style.width = (rad * 2)+"px";
	bull.style.height = (rad * 2)+"px";
	bull.style.top = (gauge.centerY - rad)+"px";
	bull.style.left = (gauge.centerX - rad)+"px";
	
	gauge.canvas = canv;
	getObj(gauge.parent).appendChild(canv);
	getObj(gauge.parent).appendChild(bull);
}



function onShow()
{
	currentHoverIndex = 0;
	FTPUploadPlugin.setWidgetVisible(true);
	_widgetIsVisible = true;
	if(0 != springFolderDelay)
		acceptSpringLoadedHover = true;
	if (!FTPUploadPlugin.uploadInProgress()) updateIdleStatus();
}

function onHide()
{
	if(window.widget) {
		FTPUploadPlugin.setWidgetVisible(false);
		FTPUploadPlugin.cancelGettingListing();
	}
	_widgetIsVisible = false;
	
	SpringloadedDirectory_FullStop();
	removeAllFrontAccounts();
	
	hoverAccount = null;
	if (null != initiateListingTimer) window.clearTimeout(initiateListingTimer);
	initiateListingTimer = null;
	
	hideError();
}









/*
 ********************************
 *      Transfer-functions      *
 ********************************
 */

// gets called on a drop. Handles the animation of the accounts and initiates the upload
function dragdrop(event)
{
	if(window.widget) {
		if (FTPUploadPlugin.uploadInProgress()) return;
	}
	
	if(!allAccounts || !allAccounts[0] || (0 == allAccounts[0].length) || (null == uploadAccount)) return;
	
	if (null != initiateListingTimer) window.clearTimeout(initiateListingTimer);
	initiateListingTimer = null;	
	
	// Fade out the account divs
	oldHoverIndex = currentHoverIndex;
	currentHoverIndex = -1;
	startAnimateAccounts();
	setTimeout("removeAllFrontAccounts();", ACCOUNT_ANIM_TIME + 100);
	
	// start the upload
	var thisuri = null;
	try {
	    thisuri = event.dataTransfer.getData("text/uri-list");	// attempt to load the URL
	} catch (ex) {  }
	
	uri = thisuri;
	
	if (undefined == uri)
	{
		showError(0, "An error occurred processing the files.<br />Please try dragging the files from the Finder.");
		return;
	}
	
	event.stopPropagation();
	event.preventDefault();
	
	isFTPUpload = (uploadAccount.kind == "FTP");
	isBonjourUpload = (uploadAccount.kind == "Bonjour");
	isBluetoothUpload = (uploadAccount.kind == "Bluetooth");
	activeUploadAccount = uploadAccount;
	
	
	// compress?
	if(isBonjourUpload && "ask" == bonjourCompressionMethod) {
		showError("Compress?", "Do you wish to compress the files before sending?", initiateCompressedTransfer, "Compress", initiateUncompressedTransfer, "No");
	}
	else if(isBonjourUpload && ((("smart" == bonjourCompressionMethod) && FTPUploadPlugin.shouldCompressTransferForFiles(uri))  ||  ("always" == bonjourCompressionMethod))) {
		setTimeout("initiateCompressedTransfer()", ACCOUNT_ANIM_TIME + 20);
	}
	else {
		setTimeout("initiateUncompressedTransfer()", ACCOUNT_ANIM_TIME + 20);
	}
}



function initiateCompressedTransfer() {
	hideError();
	hideIdleStatus();
	hideStatus();
	removeAccountScroller();
	displayHeader("Compressing...");
	
	setTimeout("initiateTransfer(true)", 10);
}

function initiateUncompressedTransfer() {
	hideError();
	hideIdleStatus();
	hideStatus();
	removeAccountScroller();
	displayHeader("Preparing...");
	
	setTimeout("initiateTransfer()", 10);
}


// do NOT call this function directly, call one of the two functions above since they will prepare the GUI what doesn't work from within this function
function initiateTransfer(compressBJ) {
	currentPercent = 0;
	uploadCancelled = false;
	
	compressBJ = compressBJ ? true : false;
	thisTransferCompressed = compressBJ;
	
	
	// some checks
	
	// FTP-upload
	if (isFTPUpload)
	{
		var pw = uploadAccount.pass;
		var user = uploadAccount.username;
		var host = uploadAccount.host;
		var omitted = ("" == user) ? "username" : (("" == pw) ? "password" : (("" == host) ? "host" : null));
		
		if(omitted)
		{
			showError(0, "No " + omitted + " specified for account &quot;" + uploadAccount.notation + "&quot;<br />please specify it", switchToAccountPrefs);
			return;
		}
		
		FTPUploadPlugin.prepareUpload(uri, uploadAccount.getRemotePath(), user, pw, (undefined == uploadAccount.httppath ? '' : uploadAccount.httppath));
		displayCopyButton();
	}
	
	// Bonjour upload
	else if (isBonjourUpload) {
		// other uploads
		if (!FTPUploadPlugin.prepareBonjourUpload(uri, uploadAccount.notation.replace(/<br \/>/, "\n"), compressBJ))
		{
			showError(0, "An internal plugin error occurred.");
			return;
		}
	}
	
	// Bluetooth upload
	else if (isBluetoothUpload) {
		if (!FTPUploadPlugin.prepareBluetoothUpload(uri, uploadAccount.notation))
		{
			showError(0,"A Bluetooth error occurred<br />Is the device in range?");
			return;
		}
	}
	
	
	// prepare the GUI
	blockiButton('transfer');
	
	
	// create and show the files on the front
	var files = FTPUploadPlugin.filesToBeUploaded();
	uploadFiles = new Object();
	var firstFile = null;
	
	for(i = 0; i < files.length; i++) {
		var thisFile = new uploadFileObj(files[i], i + 1);
		if(thisFile) {
			thisFile.add();				// decides on itself if it must add the icon or not, based on the index
			if(0 == i) {
				firstFile = thisFile;
			}
		}
	}
			
	setTimeout("fadeElements(0, 1, new Array('percentGaugeBackground', 'speedGaugeBackground', 'percentGaugeGlass', 'speedGaugeGlass', 'cancelButton'));", 10);
	setTimeout("prepareGUIForTransfer();", 15);
	
	/* DEBUG GUI
	firstFile.prepare();
	secondsRemaining(162);
	return;		// */
	
	if (isFTPUpload) setTimeout("FTPUploadPlugin.startUpload();", FADE_ANIM_TIME + 10);
	else if (isBonjourUpload) setTimeout("FTPUploadPlugin.startBonjourUpload();", FADE_ANIM_TIME + 10);
	else if (isBluetoothUpload) setTimeout("FTPUploadPlugin.startBluetoothUpload();", FADE_ANIM_TIME + 10);
}


function prepareGUIForTransfer()
{
	mouseexit();
	
	if (!isBonjourUpload) displayHeader("");
	else displayHeader("Connecting...");
	
	clearDisplay('uploadFileProgress');
	clearDisplay('uploadKBS');
	
	kbsGauge.max = 25;
	drawGauge(percentGauge, 0);
	drawGauge(kbsGauge, 0);
}




var uploadIconRatio = 1.5;
var uploadIconAnimTime = 300;
var uploadIconSize = new Array();		var uploadIconOpacity = new Array();			var uploadIconX = new Array();			var uploadIconY = new Array();
uploadIconSize[0] = 48;					uploadIconOpacity[0] = 1;						uploadIconX[0] = 66;					uploadIconY[0] = 58;
uploadIconSize[1] = 24;					uploadIconOpacity[1] = 1;						uploadIconX[1] = 100;					uploadIconY[1] = 53;
uploadIconSize[2] = 20;					uploadIconOpacity[2] = 0.95;					uploadIconX[2] = 114;					uploadIconY[2] = 50;
uploadIconSize[3] = 16;					uploadIconOpacity[3] = 0.8;						uploadIconX[3] = 125;					uploadIconY[3] = 48;
uploadIconSize[4] = 14;					uploadIconOpacity[4] = 0.6;						uploadIconX[4] = 133;					uploadIconY[4] = 47;
uploadIconSize[5] = 12;					uploadIconOpacity[5] = 0.4;						uploadIconX[5] = 140;					uploadIconY[5] = 46;
uploadIconSize[6] = 11;					uploadIconOpacity[6] = 0.2;						uploadIconX[6] = 146;					uploadIconY[6] = 46;


// this Object holds a file to upload
function uploadFileObj(path, index) {
	if(!this instanceof uploadFileObj) {
		return new uploadFileObj(path, index);
	}
	
	if(!path)
		return null;
	
	this.path = path;
	this.name = this.path.split("/");			this.name = this.name[this.name.length - 1];
	this.parent = getObj('frontMain');
	this.index = index;
	this.added = false;
	
	uploadFiles[this.path] = this;
	
	// XHTML elements
	this.icon = document.createElement('img');
	this.icon.setAttribute('class', "uploadImage");
	if(window.widget) {
		this.icon.setAttribute('src', "data:image/png;base64," + FTPUploadPlugin.reflectingIconForFile(this.path));
		//alert("<img src='" + this.icon.src + "' alt='' />");
	}
	
	// ****
	// show file on front
	this.add = function() {
		if(this.index > 6)
			return;
		
		var width = uploadIconSize[this.index] ? uploadIconSize[this.index] : 12;
		var height = Math.floor(width * uploadIconRatio);
		this.icon.setAttribute('style', "width:" + width + "px; height:" + height + "px; opacity:" + uploadIconOpacity[this.index] + "; z-index:" + (7 - this.index));
		this.icon.style.left = uploadIconX[this.index];
		this.icon.style.top = uploadIconY[this.index];
		
		// add
		this.parent.appendChild(this.icon);
		this.added = true;
	}
		
	// prepares this file for upload; this function takes care of all following images and animates them accordingly
	this.prepare = function() {
		if(!this.added)
			return;
		
		var displayname = this.name;
		if (isBonjourUpload && thisTransferCompressed) displayname = "Archive";
		displayHeader(FTPUploadPlugin.escapedString(displayname));
		animateKBSGauge(0);
		
		// put first 7 files in our array and...
		var files = new Array();
		var shifted = 0;
		for(var f in uploadFiles) {
			files.push(uploadFiles[f]);
			if(++shifted > 6)
				break;
		}
		
		// ...add/animate this and the other files
		for(var i = 0; i < files.length; i++) {
			var file = files[i];
			file.index--;
			if(!file.added) {
				file.index = 6;
				file.add();
			}
			
			if(_widgetIsVisible) {
				file.animateToPos();
			}
			else {
				file.moveToPos();
			}
		}
	}
	
	// move to position
	this.moveToPos = function() {
		if(!this.added)
			return;
		
		if(0 != this.index) {		// maybe we're already fading it out since we began to upload this file. Don't change the opacity though.
			this.icon.style.opacity = uploadIconOpacity[this.index];
		}
		this.icon.style.width = uploadIconSize[this.index] + 'px';
		this.icon.style.height = Math.floor(uploadIconSize[this.index] * uploadIconRatio) + 'px';
		this.icon.style.top = uploadIconY[this.index] + 'px';
		this.icon.style.left = uploadIconX[this.index] + 'px';
		this.icon.style.zIndex = (7 - this.index);
	}
	
	// animate to next position
	this.animateToPos = function() {
		if(!this.added)
			return;
		
		this.startX = parseInt(this.icon.style.left);
		this.startY = parseInt(this.icon.style.top);
		this.startSize = parseInt(this.icon.style.width);
		this.endX = uploadIconX[this.index];
		this.endY = uploadIconY[this.index];
		this.endSize = uploadIconSize[this.index];
		
		var now = (new Date()).getTime();
		this.startTime = now;
		this.stopTime = now + uploadIconAnimTime;
		
		setTimeout("uploadFiles['" + this.path + "'].doAnimateToPos()", 10);
	}
	
	this.doAnimateToPos = function() {
		var now = (new Date()).getTime();
		if(now < this.stopTime) {
			var delta = (now - this.startTime) / uploadIconAnimTime;
			var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
			var valueX = ((1.0-factor) * this.startX) + (factor * this.endX);
			var valueY = ((1.0-factor) * this.startY) + (factor * this.endY);
			var width = ((1.0-factor) * this.startSize) + (factor * this.endSize);
			var height = width * uploadIconRatio;
			
			this.icon.style.width = width + 'px';
			this.icon.style.height = height + 'px';
			this.icon.style.top = valueY + 'px';
			this.icon.style.left = valueX + 'px';
			
			setTimeout("uploadFiles['" + this.path + "'].doAnimateToPos()", 20);
		}
		else {
			this.moveToPos();
		}
	}
	
	this.percentDone = function(percent) {
		if(this.added) {
			this.icon.style.opacity = 1 - percent;
		}
	}
	
	// file done; remove
	this.done = function() {
		if(this.added) {
			try {
				this.parent.removeChild(this.icon);
			} catch(exc) {  }
		}
		delete uploadFiles[this.path];
		
		displayHeader('');
		clearDisplay('uploadKBS');
		animateKBSGauge(0);
	}
}


function prepareUpload(file)
{
	if(uploadFiles[file])
		uploadFiles[file].prepare();
}

function fileDone(file)
{
	if(uploadFiles[file])
		uploadFiles[file].done();
}

function clearUploadFiles() {
	for(var p in uploadFiles) {
		var file = uploadFiles[p];
		if(file)
			file.done();
	}
}





// displays the remaining upload time
function displayRemainingTime(remaining) {
	var rem = remaining ? remaining : '';
	var elem = getObj('uploadSecondsRemaining');
	elem.style.display = 'block';
	elem.innerText = rem;
}

function hideRemainingTime() {
	var elem = getObj('uploadSecondsRemaining');
	elem.style.display = 'none';
	elem.innerText = '';
}


// displays the right statusmessage/filename
function displayHeader(text, fade) {
	var elem = getObj('uploadFileName');
	var testelem = getObj('uploadFileNameTestElem');
	if(text) {
		elem.setAttribute('style', '');
		testelem.setAttribute('style', '');
		var limit = 86;
		
		testelem.innerHTML = text;
		var width = parseInt(getComputedValue('width', testelem));
		
		// step 1: use narrow font
		if(width > limit) {
			testelem.setAttribute('style', "font-family:'Arial Narrow', Arial, sans-serif");
			width = parseInt(getComputedValue('width', testelem));
			
			// step 2: use smaller and narrow font
			if(width > limit) {
				elem.setAttribute('style', "height:12px; left:62px; right:62px; font-size:10px; font-family:'Arial Narrow', Arial, sans-serif");
				text = "<marquee scrollamount=\"2\" scrolldelay=\"20\">" + text + "</marquee>";
			}
			else {
				elem.setAttribute('style', "font-family:'Arial Narrow', Arial, sans-serif");
			}
			//elem.innerHTML = (width > limit) ? "<marquee scrollamount=\"2\" scrolldelay=\"50\">" + text + "</marquee>" : text;			// OLD METHOD
		}
		
		elem.innerHTML = text;
		testelem.innerHTML = '';
	}
	
	if(fade) {
		fadeElements(0, 1, new Array('uploadFileName'));
		fadeElements(1, 0, new Array('idleStatusMessage', 'statusIndicator'));
	}
	else {
		elem.style.display = 'block';
		hideIdleStatus();
		hideStatus();
	}
}

// hides the statusmessage/filename
function hideHeader(fade) {
	if(fade) {
		fadeElements(1, 0, new Array('uploadFileName'));
	}
	else {
		getObj('uploadFileName').style.display = 'none';
	}
}

// displays the copy-button and hides the 'i' - flip
function displayCopyButton() {
	fadeElements(0, 1, new Array('copyFileURIButton'));
	mouseexit();
	blockiButton('copybutton');
}

// hides the copy-button
function hideCopyButton() {
	fadeElements(1, 0, new Array('copyFileURIButton'));
	
	setTimeout("restoreCopyButton()", FADE_ANIM_TIME);
	setTimeout("releaseiButton('copybutton');", FADE_ANIM_TIME);
}

function restoreCopyButton() {
	var copybutton = getObj('copyFileURIButton');
	copybutton.src = "Images/copybutton.png";
	copybutton.setAttribute('onmouseout', "this.src='Images/copybutton.png';hideMessage();");
	copybutton.setAttribute('onmouseover', "this.src='Images/copybutton_hover.png';displayMessage('copy');");
}

// copies the URLs to the clipboard
function copyURLs()
{
	if(window.widget) {
		FTPUploadPlugin.copyRemotePathsToClipboard();
		displayMessage('copy_ok');
		
		var copybutton = getObj('copyFileURIButton');
		copybutton.setAttribute('onmouseout', "this.src='Images/copybutton_green.png';hideMessage();");
		copybutton.setAttribute('onmouseover', "this.src='Images/copybutton_hover.png';displayMessage('copy_ok');");
	}
}








function drawGauge(gauge, value)
{
	var gMax = gauge.max;
	if (value > gMax) 
	{
		if (gauge == kbsGauge)
		{
			gMax = value;
			kbsGauge.max = Math.ceil(value);
		} else {
			value = gMax;
		}
	}
	var gMin = gauge.min;
	if (value < gMin) value = gMin;
	
	gauge.current = value;
	
	var fraction = (value - gMin) / (gMax - gMin);
	var radius = gauge.radius;

	var context = gauge.canvas.getContext("2d");
	context.clearRect(0, 0, radius*2, radius*2);

	context.save();
	context.translate(radius, radius);
	context.rotate(-1.9 + (fraction * 3.8));
	context.translate(-radius, -radius);
	
	context.drawImage(pointerImage, -0, 0);
	
	context.restore();
}


function currentKBS(kbs)
{
	var kbsec = Math.floor(kbs*10) / 10;
	displaySpeed(kbsec);
	animateKBSGauge(kbsec);
}

function animateKBSGauge(val)
{
	//alert('animateKBSGauge(' + val + ')');
	if (kbsGaugeAnim.timeout != null) window.clearTimeout(kbsGaugeAnim.timeout);
	if (val == kbsGauge.current) return;
	kbsGaugeAnim.startValue = kbsGauge.current;
	kbsGaugeAnim.stopValue = val;
	
	var now = (new Date()).getTime();
	kbsGaugeAnim.startTime = now;
	kbsGaugeAnim.stopTime = now + kbsGaugeAnim.animTime;
	kbsGaugeAnim.timeout = setTimeout("doAnimateKBSGauge();", 10);
}

function doAnimateKBSGauge()
{
	var now = (new Date()).getTime();
	if (now < kbsGaugeAnim.stopTime)
	{
		var delta = (now - kbsGaugeAnim.startTime) / kbsGaugeAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * kbsGaugeAnim.startValue) + (factor * kbsGaugeAnim.stopValue);
		drawGauge(kbsGauge, value);
		
		kbsGaugeAnim.timeout = setTimeout("doAnimateKBSGauge();", 20);
	} else {
		drawGauge(kbsGauge, kbsGaugeAnim.stopValue);
	}
}


function percentDone(file, thispercent, allpercent)
{
	var thisfile = uploadFiles[file];
	if(thisfile)
		thisfile.percentDone(thispercent);
	
	var perc = Math.floor(allpercent*100);
	displayPercent(perc);
	
	var delta = allpercent - currentPercent;
	if(delta > .02) {
		currentPercent = allpercent;
		animatePercentGauge(allpercent);
	}
}


function animatePercentGauge(val)
{
	if (percentGaugeAnim.timeout != null) window.clearTimeout(percentGaugeAnim.timeout);
	if (val == percentGauge.current) return;
	percentGaugeAnim.startValue = percentGauge.current;
	percentGaugeAnim.stopValue = val;
	
	var now = (new Date()).getTime();
	percentGaugeAnim.startTime = now;
	percentGaugeAnim.stopTime = now + percentGaugeAnim.animTime;
	percentGaugeAnim.timeout = setTimeout("doAnimatePercentGauge();", 20);
}

function doAnimatePercentGauge()
{
	var now = (new Date()).getTime();
	if (now < percentGaugeAnim.stopTime)
	{
		var delta = (now - percentGaugeAnim.startTime) / percentGaugeAnim.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * percentGaugeAnim.startValue) + (factor * percentGaugeAnim.stopValue);
		
		drawGauge(percentGauge, value);
		
		percentGaugeAnim.timeout = setTimeout("doAnimatePercentGauge();", 10);
	} else {
		drawGauge(percentGauge, percentGaugeAnim.stopValue);
	}
}



function secondsRemaining(secs)
{
	if (0 == secs)
	{
		displayRemainingTime();
		return;
	}
	var minutes = Math.floor(secs/60);
	var seconds = secs % 60;
	
	displayRemainingTime(minutes + ":" + (seconds < 10 ? "0" : "") + seconds);
}



// FAKE directory animation! fade it out over 200ms			>>>			does not work since we must remove the foremost icon when it is done!!!
var directoryAnimation = { startTime:0, stopTime:0, animTime:200 };

function directoryDone(dir)
{
	uploadFiles[dir].done();
	//animateDirectory(dir);
}

function animateDirectory(dir)
{
	if(uploadFiles && uploadFiles[dir]) {
		var now = (new Date()).getTime();
		directoryAnimation.startTime = now;
		directoryAnimation.stopTime = now + directoryAnimation.animTime;
		setTimeout("doAnimateDirectory('" + dir + "');", 10);
	}
}

function doAnimateDirectory(dir)
{
	var now = (new Date()).getTime();
	if (now < directoryAnimation.stopTime && uploadFiles[dir]) {
		var delta = (now - directoryAnimation.startTime) / directoryAnimation.animTime;
		uploadFiles[dir].percentDone(delta);
		
		setTimeout("doAnimateDirectory(\"" + dir + "\");", 20);
	}
	else {
		uploadFiles[dir].done();
	}
}



var definedErrors = new Array();
definedErrors[7] = "Could not connect";
definedErrors[530] = "Login failed";
definedErrors[550] = "No permission";


function errorOccurred()
{
	errorOccurred("An error occurred while uploading.<br />The upload was cancelled.");
}

function errorOccurred(error)
{
	clearUploadFiles();
	uploadDone('with_error');
	
	if(window.widget) {
		FTPUploadPlugin.beep();
	}
	
	var errstr = "An error occurred";
	if(error) {
		//alert('error: ' + error);
		var reg = /code=(\d+)/i;
		var errarr = reg.exec(error);
		if(errarr && definedErrors[errarr[1]]) {
			errstr = "An error occurred:<br />" + definedErrors[errarr[1]];
		}
		else {
			errstr = error;
		}
	}

	showError(0, errstr);
}

function transferRejected()
{
	clearUploadFiles();
	uploadDone('with_error');

	FTPUploadPlugin.beep();

	errorOccurred("The receiver rejected the transfer.<br />The transfer was cancelled.");
}


// gets called if upload is done; cleans up
function uploadDone(with_error) {
	hideRemainingTime();
	
	hideHeader(1);
	animatePercentGauge(0);
	animateKBSGauge(0);
	
	setTimeout("hideCopyButton();", (isBonjourUpload || with_error) ? 10 : AUTO_CHANGE_STATUS_AFTER);
	setTimeout("releaseiButton('transfer');", (isBonjourUpload || with_error) ? 10 : AUTO_CHANGE_STATUS_AFTER);
	setTimeout("fadeElements(1, 0, new Array('percentGaugeBackground', 'speedGaugeBackground', 'percentGaugeGlass', 'speedGaugeGlass', 'cancelButton', 'uploadMessageArea'));", 10);
	
	var stat = 'successful';
	if(uploadCancelled)
		stat = 'cancelled';
	else if(with_error)
		stat = 'error';
	else
		playUploadSound();
	
	restoreCancelButton();
	setTimeout("displayStatus('" + stat + "')", 10);
	setTimeout("updateIdleStatus(true)", 15);
}


// prepares the cancel-button for the second definitive click
function askCancelUpload() {
	var image = getObj('cancelButton');
	
	image.src = "Images/cancelbutton_confirm.png";
	image.setAttribute('onclick', "cancelUpload()");
	image.setAttribute('onmouseover', "displayMessage('cancel_sure');");
	image.setAttribute('onmouseout', "hideMessage();");
	
	displayMessage('cancel_sure');
	
	setTimeout("restoreCancelButton()", AUTO_CHANGE_STATUS_AFTER);
	setTimeout("hideMessage()", AUTO_CHANGE_STATUS_AFTER);
}

// restores the cancel button back to the default state
function restoreCancelButton() {
	var image = getObj('cancelButton');
	
	image.src = "Images/cancelbutton.png";
	image.setAttribute('onclick', "askCancelUpload()");
	image.setAttribute('onmouseover', "this.src='Images/cancelbutton_hover.png';displayMessage('cancel');");
	image.setAttribute('onmouseout', "this.src='Images/cancelbutton.png';hideMessage();");
}


// cancels an upload
function cancelUpload()
{
	if (!FTPUploadPlugin.uploadInProgress()) return;
	FTPUploadPlugin.cancelUpload();
	
	clearUploadFiles();
	uploadCancelled = true;
	
	setTimeout("uploadDone('with_error')", isBluetoothUpload ? 300 : 10);		// the Plugin needs some time to cancel
}





// displays the number of available services
function updateIdleStatus(dont_recheck) {
	if(accountsShowingOnFront || (window.widget && FTPUploadPlugin.uploadInProgress()))
		return;
	
	var now = (new Date()).getTime();
	
	// dont check more often than 2/3 the time of AUTO_CHANGE_STATUS_AFTER
	if(lastIdleScanTime && (lastIdleScanTime + (AUTO_CHANGE_STATUS_AFTER / 1.5) > now))
		return;
	
	// clear the GUI
	hideHeader();
	
	// re-check again after AUTO_CHANGE_STATUS_AFTER if last check is older than 15 minutes
	var re_check = (!dont_recheck && lastIdleScanTime && (lastIdleScanTime + (15 * 60 * 1000) < now));
	
	// FTP
	var numFTP = 0;
	var FTPimgName = "FTP_off_Status.png";
	if(allAccounts && allAccounts[0]) {
		for (i = 0; i < allAccounts[0].length; i++)
		{
			if (allAccounts[0][i].kind == "FTP") numFTP++;
		}
	}
	if(0 == numFTP) {
		numFTP = '';
	}
	else {
		FTPimgName = "FTP_Status.png";
	}
	var ftpobj = getObj('statusFTP');
	ftpobj.style.display = 'block';
	ftpobj.innerHTML = "<img class=\"statusIcon\" src=\"Images/" + FTPimgName + "\" alt=\"FTP\" />" + numFTP;
	
	
	// Bonjour
	var numBonjour = "~";
	var BJimgName = "Bonjour_Status.png";
	if(!re_check) {
		numBonjour = window.widget ? FTPUploadPlugin.numberOfBonjourUsers() : null;
		if(null == numBonjour) {
			numBonjour = '';
			BJimgName = "Bonjour_off_Status.png";
		}
	}
	var bonjourobj = getObj('statusBonjour');
	bonjourobj.style.display = 'block';
	bonjourobj.innerHTML = "<img class=\"statusIcon\" src=\"Images/" + BJimgName + "\" alt=\"Bonjour\" />" + numBonjour;
	
	
	// Bluetooth
	var numBluetooth = '';
	var BTimgName = "Bluetooth_off_Status.png";
	if(enableBluetooth && (window.widget && FTPUploadPlugin.bluetoothAvailable())) {
		numBluetooth = "~";
		BTimgName = "Bluetooth_Status.png";
		if(!re_check) {
			var bt_arr = FTPUploadPlugin.bluetoothDeviceNames();
			if(bt_arr) {
				numBluetooth = bt_arr.length;
				if(0 == numBluetooth) {
					numBluetooth = '';
					BTimgName = "Bluetooth_off_Status.png";
				}
			}
		}
	}
	var bluetoothobj = getObj('statusBluetooth');
	bluetoothobj.style.display = 'block';
	bluetoothobj.innerHTML = "<img class=\"statusIcon\" src=\"Images/" + BTimgName + "\" alt=\"Bluetooth\" />" + numBluetooth;
	
	// re check
	if(re_check) {
		setTimeout("updateIdleStatus(true)", AUTO_CHANGE_STATUS_AFTER);
	}
	
	lastIdleScanTime = now;
}

function hideIdleStatus() {
	lastIdleScanTime = 0;
	
	var ftpobj = getObj('statusFTP');
	ftpobj.style.display = 'none';
	
	var bonjourobj = getObj('statusBonjour');
	bonjourobj.style.display = 'none';
	
	var bluetoothobj = getObj('statusBluetooth');
	bluetoothobj.style.display = 'none';
}


// displays the statusmessage
var statusIsFadedOut = false;
function displayStatus(status) {
	var poss = new Array('none', 'drop_files', 'ready', 'successful', 'cancelled', 'error');		// drop_files is only used on launch!
	if(!inArray(status, poss))
		status = 'ready';
	
	// do not show anything
	if(accountsShowingOnFront || (window.widget && FTPUploadPlugin.uploadInProgress()))
		status = 'none';
	
	//alert("displayStatus() has status: " + status);
	var elem = getObj('statusIndicator');
	if('none' == status) {
		elem.style.display = 'none';
	}
	else if('ready' == status) {
		if(!statusIsFadedOut) {
			fadeElements(1, 0, new Array('statusIndicator'));
			statusIsFadedOut = true;
		}
	}
	
	// special status; resets itself
	else {
		elem.style.backgroundImage = "url(Images/Status_" + status + ".png)";
		if(statusIsFadedOut) {
			fadeElements(0, 1, new Array('statusIndicator'));
			statusIsFadedOut = false;
		}
		else {
			elem.style.display = 'block';
		}
		
		setTimeout("displayStatus('ready')", AUTO_CHANGE_STATUS_AFTER);
	}
}

// hides the statusmessage
function hideStatus() {
	getObj('statusIndicator').style.display = 'none';
}






// displays the statusmessage
var messageIsFadedOut = true;
function displayMessage(message) {
	var poss = new Array('cancel', 'cancel_sure', 'copy', 'copy_ok');
	
	if(!inArray(message, poss) || accountsShowingOnFront || !(window.widget && FTPUploadPlugin.uploadInProgress())) {
		hideMessage();
		return;
	}
	
	//alert('Message is ' + message);
	var elem = getObj('uploadMessageArea');
	elem.style.backgroundImage = "url(Images/Message_" + message + ".png)";
	if(messageIsFadedOut) {
		fadeElements(0, 1, new Array('uploadMessageArea'));
		messageIsFadedOut = false;
	}
	else {
		elem.style.display = 'block';
	}
}

// hides the statusmessage
function hideMessage() {
	if(!messageIsFadedOut) {
		fadeElements(1, 0, new Array('uploadMessageArea'));
		messageIsFadedOut = true;
	}
}






// ******
// Element fading
// we create a 'fadeElementsSetting'-object which holds all fading information
// this object gets put onto 'fadeElementsArray' where we can access it any time
// all elements we fade get injected into 'fadeElementsInUse', where we can get the fadeElementsSetting-ID where each object is used
// upon fade-completion, the object gets destroyed. This means we can run as many 'fadeElements()' at any time as we want.

var fadeElementsArray = new Array();		// holds all current fading objects 'fadeElementsSetting'
var fadeElementsInUse = new Array();		// holds all elements being faded ATM

function fadeElementsSetting(id, from, to, elements) {
	if(!(this instanceof fadeElementsSetting))
		return new fadeElementsSetting(id, from, to, elements);
	
	// the properties
	this.id = id ? id : 666;
	this.startValue = isNaN(from) ? 0 : from;
	this.stopValue = isNaN(to) ? 1 : to;
	this.elements = elements;
	
	// set animation vars
	var now = (new Date()).getTime();
	this.startTime = now;
	this.animTime = FADE_ANIM_TIME;
	this.stopTime = now + this.animTime;
	
	// check for elements already in use and remove them from their old fading
	if(this.elements) {
		for(i = 0; i < this.elements.length; i++) {
			
			// remove from old element-array if already in use
			if(fadeElementsInUse[this.elements[i]]) {
				var old_id = fadeElementsInUse[this.elements[i]];
				
				if(fadeElementsArray[old_id].elements) {
					for(var n = 0; n < fadeElementsArray[old_id].elements.length; n++) {
						if(this.elements[i] == fadeElementsArray[old_id].elements[n]) {
							//alert("already on element-stack! removing from old stack: " + this.elements[i]);
							fadeElementsArray[old_id].elements.splice(n, 1);
						}
					}
				}
			}
			
			// add to the 'used'-stack
			fadeElementsInUse[this.elements[i]] = this.id;
		}
	}
	
	this.deleteMe = function() {
		for(i = 0; i < this.elements.length; i++) {
			if(fadeElementsInUse[this.elements[i]]) {
				delete fadeElementsInUse[this.elements[i]];
			}
		}
	}
}


// fades given elements in/out
function fadeElements(from, to, elements) {
	if(!elements || (elements.length < 1))
		return;
	
	// set settings
	var this_id = (new Date()).getTime() + Math.round(100000 * Math.random());
	fadeElementsArray[this_id] = new fadeElementsSetting(this_id, from, to, elements);
	
	// display hidden elements
	if(from == 0) {
		for(i = 0; i < elements.length; i++) {
			var elem = getObj(elements[i]);
			elem.style.opacity = 0;
			elem.style.display = 'block';
		}
	}
	
	setTimeout("doFadeElements(" + this_id + ");", 10);
}


// does the work for fadeElements()
function doFadeElements(this_id) {
	var now = (new Date()).getTime();
	var fadeElems = fadeElementsArray[this_id];
	if(!fadeElems || !fadeElems.elements)
		return;
	
	// while fading
	if(now < fadeElems.stopTime) {
		var delta = (now - fadeElems.startTime) / fadeElems.animTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var value = ((1.0-factor) * fadeElems.startValue) + (factor * fadeElems.stopValue);
		
		for(var i = 0; i < fadeElems.elements.length; i++) {
			getObj(fadeElems.elements[i]).style.opacity = value;
		}
		setTimeout("doFadeElements(" + this_id + ");", 20);
	}
	
	// end fading
	else {
		for(var i = 0; i < fadeElems.elements.length; i++) {
			var elem = getObj(fadeElems.elements[i]);
			elem.style.opacity = fadeElems.stopValue;
			
			// hide them completely if needed, but reset their opacity
			if(0 == fadeElems.stopValue) {
				elem.style.display = 'none';
				elem.style.opacity = 1;
			}
		}
		
		// clean up
		fadeElementsArray[this_id].deleteMe();
		delete fadeElementsArray[this_id];
	}
}






// displays the desired (error-)dialog
function showError(errorTitle, errorHTML, mainFunction, mainText, altFunction, altText) {
	getObj('errorTitle').innerHTML = errorTitle ? errorTitle : "Error";
	getObj('errorMessage').innerHTML = errorHTML;
	
	//var err_ok = createDialogButton(getObj('errorDivOKButton'), mainText, mainFunction, 20);
	//var err_cnc = altText ? createDialogButton(getObj('errorDivCancelButton'), altText, altFunction, 20) : null;
	
	var err_ok = getObj('errorDivOKButton');
	var err_cnc = getObj('errorDivCancelButton');
	
	// primary (rightmost) button
	if('function' == typeof(mainFunction)) {
		err_ok.setAttribute('genericButtonOnAction', mainFunction);
		err_ok.genericButtonAction = mainFunction;
	}
	else {
		err_ok.setAttribute('genericButtonOnAction', hideError);
		err_ok.genericButtonAction = hideError;
	}
	err_ok.firstChild.nextSibling.innerHTML = (mainText && ('' != mainText)) ? mainText : "OK";
	
	// additional button
	if('function' == typeof(altFunction)) {
		//alert("altFunction set");
		err_cnc.setAttribute('genericButtonOnAction', altFunction);
		err_cnc.genericButtonAction = altFunction;
		err_cnc.firstChild.nextSibling.innerHTML = (altText && ('' != altText)) ? altText : "Cancel";
		err_cnc.style.display = 'block';
	}
	else {
		err_cnc.style.display = 'none';
	}
	
	// hide the i-button
	blockiButton('error_dialog');
	mouseexit();
	
	// do it
	genericButtonSetEnabled(getObj(errorDivOKButton), 1);
	getObj('errorDiv').style.display = 'block';
}

function hideError() {
	updateIdleStatus();
	releaseiButton('error_dialog');
	
	getObj('errorDiv').style.display = 'none';
}




function findUserAndPass(host)
{
	if (host.length < 4) return;
	var result = FTPUploadPlugin.authorizationForHost(host);
	if (result.length == 2)
	{
		var form = document.forms['prefform'];
		form.acc_user.value	= result[0];
		form.acc_pass.value = result[1];
	}
}

function findPass(host, user)
{
	// For some reason, "host" doesn't seem to be a string to the Cocoa-JS bridge,
	// so, explicitly make it a string.
	var result = FTPUploadPlugin.authorizationForHostAndUsername(""+host, user);
	if (result != "")
	{
		var form = document.forms['prefform'];
		form.acc_pass.value = result;
	}
}


/*
 ***************************
 *  Animation of Accounts  *
 ***************************
 */

var animationStart = 0;
var animationStop = 0;
var real_account_anim_time = ACCOUNT_ANIM_TIME;			// still needed to reset after changing the time when pressing SHIFT


// responsible for initiating the Accounts on first hover (that means _not_ while navigating spring-loaded folders)
function dragenter(event)
{
	// return if an upload is already in progress, we`re already showing the accounts or if the prefs are shown
	if(accountsShowingOnFront || prefsShown)
		return;
	
	if(window.widget) {
		if(FTPUploadPlugin.uploadInProgress())
			return;
		
		hideError();
		hideIdleStatus();
		hideStatus();
		mouseexit();
		blockiButton('front_accounts');
		
		// delete old Bonjour/Bluetooth accounts
		for (i = 0; i < allAccounts[0].length; i++)
		{
			if ((allAccounts[0][i].kind == "Bonjour") || (allAccounts[0][i].kind == "Bluetooth")) allAccounts[0].splice(i--, 1);
		}
		
		// add current Bonjour accounts
		var bonjourServices = FTPUploadPlugin.availableBonjourServices();
		
		for (i = 0; i < bonjourServices.length; i++)
		{
			allAccounts[0].push(new Account(bonjourServices[i], "", "", "", "", "", "Bonjour"));
		}
		
		// add Bluetooth devices
		if (enableBluetooth && FTPUploadPlugin.bluetoothAvailable())
		{
			var bluetoothDevices = FTPUploadPlugin.bluetoothDeviceNames();
			for (i = 0; i < bluetoothDevices.length; i++)
			{
				allAccounts[0].push(new Account(bluetoothDevices[i], "", "", "", "", "", "Bluetooth"));
			}
		}
		
		if(!allAccounts || !allAccounts[0] || allAccounts[0].length == 0) {
			showError(0, "No accounts configured, please configure one", switchToAccountPrefs, 'Configure');
			return;
		}
	
		uploadAccount = null;
		
		currentHoverIndex = 0;
		startAnimateAccounts();
	}
	else {
		showError(0, "This widget must be used from within Dashboard");
	}
}


// animates new accounts in
function startAnimateAccounts() {
	
	// load new Accounts
	prepareAccountsForAnimation();
	
	accountsShowingOnFront = true;
	acceptSpringLoadedHover = false;
	
	// set animation values for the old Accounts (if there are any)
	if((oldHoverIndex > -1) && allAccounts[oldHoverIndex]) {
		for (i = 0; i < allAccounts[oldHoverIndex].length; i++)
		{
			var anim = allAccounts[oldHoverIndex][i].animation;
			anim.startTransparency = 1;
			anim.finalTransparency = 0;
			
			// the hovered Account
			if (hoverAccount == allAccounts[oldHoverIndex][i])
			{
				anim.startLeft = anim.finalLeft;
				anim.startTop = anim.finalTop;
				anim.startWidth = anim.finalWidth;
				anim.startHeight = anim.finalHeight;
			}
			
			// all other Accounts
			else {
				anim.startLeft = anim.finalLeft;
				anim.startTop = anim.finalTop;
				anim.startWidth = anim.finalWidth;
				anim.startHeight = anim.finalHeight;
				anim.finalLeft = 110;
				anim.finalTop = 90;
				anim.finalWidth = 0;
				anim.finalHeight = 0;
			}
	
			allAccounts[oldHoverIndex][i].animateAt(0);
		}
	}
	
	var now = (new Date()).getTime();
	animationStart = now;
	animationStop = now + ACCOUNT_ANIM_TIME;
	setTimeout("doAnimateAccounts();", 10);
}


// prepares accounts for animation by appending them to the front-div and setting the initial anim-values
function prepareAccountsForAnimation()
{
	// if currentHoverIndex is below 0, we dont want new accounts to appear.
	if(currentHoverIndex < 0)
		return;
	
	// get the div
	var div = getObj('AccountFrontside_div');
	
	// calculate the size for one account div
	var numAccounts = allAccounts[currentHoverIndex].length;
	var numColumns = Math.floor(Math.sqrt(numAccounts));
	var numRows = Math.ceil(numAccounts / numColumns);
	
	var width = FRONT_WIDTH;
	var height = FRONT_HEIGHT;
	div.style.top = '0px';
	div.style.left = '0px';
	
	// 1 or 2 accounts, override some settings from above
	if(numAccounts <= 2) {
		width = FRONT_MINI_WIDTH;
		height = FRONT_MINI_HEIGHT;
		div.style.top = Math.round((FRONT_HEIGHT - FRONT_MINI_HEIGHT) / 2) + "px";
		div.style.left = Math.round((FRONT_WIDTH - FRONT_MINI_WIDTH) / 2) + "px";
	}
	
	// 3 or 4 accounts
	else if(numAccounts <= 4) {
		width = FRONT_MIDI_WIDTH;
		height = FRONT_MIDI_HEIGHT;
		div.style.top = Math.round((FRONT_HEIGHT - FRONT_MIDI_HEIGHT) / 2) + "px";
		div.style.left = Math.round((FRONT_WIDTH - FRONT_MIDI_WIDTH) / 2) + "px";
	}
	
	// too many accounts (want to scroll)
	else if(numAccounts > 12) {
		numColumns = 3;
		numRows = Math.ceil(numAccounts/numColumns);
		height = 55 * numRows;
	}
	
	div.style.width = width + "px";
	div.style.height = height + "px";
	
	var centerX = width / 2;
	var centerY = height / 2;
	var interAccountSpacing = 10;
	
	var widthPerAcc = (width / numColumns);
	var heightPerAcc = (height / numRows);
	
	// clean eventually running warnings and the scrollthingies
	stopFTPDirWarning();
	removeAccountScroller();
	
	// append them to the div and initiate animationvalues
	for (i = 0; i < numAccounts; i++)
	{
		var matrixY = Math.floor(i / numColumns);
		var matrixX = i % numColumns;
		
		var finalX = (interAccountSpacing / 2) + (matrixX * widthPerAcc);
		var finalY = (interAccountSpacing / 2) + (matrixY * heightPerAcc);
		
		var thisDiv = allAccounts[currentHoverIndex][i].frontsideofwidgetcouldntthinkofabettername;
		thisDiv.setAttribute('class', 'AccountFrontside');
		
		// start animation from middle and zero-width
		var anim = allAccounts[currentHoverIndex][i].animation;
		if (null == hoverAccount) {
			anim.startLeft = centerX;
			anim.startTop = centerY;
			anim.startWidth = 0;
			anim.startHeight = 0;
		}
		
		// start from hovered Account
		else {
			anim.startLeft = hoverAccount.animation.finalLeft;
			anim.startTop = hoverAccount.animation.finalTop;
			anim.startWidth = hoverAccount.animation.finalWidth;
			anim.startHeight = hoverAccount.animation.finalHeight;
		}
		anim.finalLeft = finalX;
		anim.finalTop = finalY;
		anim.finalWidth = widthPerAcc - interAccountSpacing;
		anim.finalHeight = heightPerAcc - interAccountSpacing;
		anim.startTransparency = 0;
		anim.finalTransparency = 1;
		
		allAccounts[currentHoverIndex][i].animateAt(0);
		
		div.appendChild(thisDiv);
	}
}



// does all the animation
function doAnimateAccounts()
{
	var now = (new Date()).getTime();
	
	// ****
	// animate
	if (now < animationStop)
	{
		var delta = (now - animationStart) / ACCOUNT_ANIM_TIME;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		//var factor = ((delta * delta) * 5.0) - ((delta * delta * delta) * 4.0);
		
		// animate new Accounts in
		if(allAccounts[currentHoverIndex] && (allAccounts[currentHoverIndex].length > 0)) {
			for(i = 0; i < allAccounts[currentHoverIndex].length; i++) {
				allAccounts[currentHoverIndex][i].animateAt(factor);
			}
		}
		
		// animate old Accounts out
		if(allAccounts[oldHoverIndex] && (allAccounts[oldHoverIndex].length > 0)) {
			for(i = 0; i < allAccounts[oldHoverIndex].length; i++) {
				allAccounts[oldHoverIndex][i].animateAt(factor);
			}
		}
		
		setTimeout("doAnimateAccounts();", 20);
	}
	
	// ****
	// end animation
	else {
		var div = getObj('AccountFrontside_div');
		
		// clean old Accounts
		if(allAccounts[oldHoverIndex] && allAccounts[oldHoverIndex].length > 0) {
			for(i = 0; i < allAccounts[oldHoverIndex].length; i++) {
				try {
					div.removeChild(allAccounts[oldHoverIndex][i].frontsideofwidgetcouldntthinkofabettername);
				}
				catch(exc) {  }
			}
			
			// remove them from our Array if we went one dir up
			if((oldHoverIndex > currentHoverIndex) && (oldHoverIndex > 0)) {
				allAccounts[oldHoverIndex] = null;
			}
		}
		
		// add new accounts; if there are none, shrink the div
		if(allAccounts[currentHoverIndex] && (allAccounts[currentHoverIndex].length > 0)) {
			for(i = 0; i < allAccounts[currentHoverIndex].length; i++) {
				allAccounts[currentHoverIndex][i].animateAt(1);
			}
		}
		else {
			div.style.height = '10px';
		}
		
		// reset some variables
		ACCOUNT_ANIM_TIME = real_account_anim_time;
		if(0 != springFolderDelay)
			acceptSpringLoadedHover = true;
		
		// add the scroll-stuff
		setTimeout("addAccountScroller()", 10);
	}
}


var SpringloadedDirectory = { account:null, div:null, animTimeout:null, animProgress:0, gettingTimeout:null, timer:null };


// gets called by spring-loading a ftp-subdir
function getSpringloadedDirectories(kind)
{
	if (!hoverAccount || (kind != hoverAccount.kind)) return;
	
	// move the directory back up
	if (true == hoverAccount.is_MoveDirUpChooser)
	{
		// tell the plugin about it. In case of bt this is necessary
		if("Bluetooth" == kind)
			FTPUploadPlugin.changeBluetoothDirectoryUp();
		
		oldHoverIndex = currentHoverIndex;
		currentHoverIndex--;
		startAnimateAccounts();
		
		return;
	}
	
	// hovering over regular directory; if switching while getting another dir, do not get subdirs of the other dir. Should not happen, but you never know. =)
	if(SpringloadedDirectory.account) {
		SpringloadedDirectory_FullStop();
	}
	
	// init
	SpringloadedDirectory.account = hoverAccount;
	SpringloadedDirectory.div = SpringloadedDirectory.account.frontsideofwidgetcouldntthinkofabettername;
	Springloaded_FlashCounter = 5;
	setTimeout("flashSpringloadedAccount()", 10);
}


// this flashes the account you're hovering and ultimately calls "subdirectoriesReceived()"
function flashSpringloadedAccount() {
	var kind = SpringloadedDirectory.account.kind;
	var orig_class = SpringloadedDirectory.account.hoverclass;
	var hoverclass = (Springloaded_FlashCounter % 2 == 0) ? orig_class : 'flash_sl';
	
	SpringloadedDirectory.div.setAttribute('class', 'AccountFrontside ' + hoverclass);
	
	// flash the shit like crazy!
	if(Springloaded_FlashCounter-- > 0)
		setTimeout("flashSpringloadedAccount();", 80);
	
	// initiate dir loading if we still hover the same account
	else if(window.widget && (SpringloadedDirectory.account === hoverAccount)) {
		acceptSpringLoadedHover = false;
		
		// calls 'subdirectoriesReceived()' when done:
		switch(kind) {
			case "FTP":
				FTPUploadPlugin.getDirectoriesAt(hoverAccount.getRemotePath(), hoverAccount.username, hoverAccount.pass);
				break;
			
			case "Bluetooth":
				FTPUploadPlugin.getBluetoothDirectories(hoverAccount.notation, /* Are we establishing the connection to a device or are we looking for directories on a device? */(0 == currentHoverIndex));
				break;
		}
		
		SpringloadedDirectory.animTimeout = setTimeout("SpringloadedDirectory_Animate()", 80);
		SpringloadedDirectory.animProgress = 0;
		SpringloadedDirectory.div.style.backgroundImage = "url(Images/whiteProgress0.png)";
		
		// set a timeout
		SpringloadedDirectory.gettingTimeout = setTimeout("SpringloadedDirectory_Timeout()", FTP_TIMEOUT);
	}
	
	// not hovering, abort
	else
		SpringloadedDirectory.div.setAttribute('class', 'AccountFrontside');
}


// This function handles all the navigation through subdirectories
function subdirectoriesReceived(subdirs)
{
	if(SpringloadedDirectory.gettingTimeout) {
		clearTimeout(SpringloadedDirectory.gettingTimeout);
		SpringloadedDirectory.gettingTimeout = null;
	}
	
	// check return value
	if(subdirs) {
		if("OK" == subdirs[0]) {				// okay, got a server response
			subdirs = subdirs.slice(1);			// a simple shift does not work here...
		}
		
		// error
		else {
			// show warning
			showFTPDirWarning(SpringloadedDirectory.account, subdirs[0]);
			
			// reset
			clearSpringloadedDirectory();
			if(0 != springFolderDelay)
				acceptSpringLoadedHover = true;
			return;
		}
	}
	else
		alert('subdirectoriesReceived(): nothing received');
	
	
	// all okay, continue
	oldHoverIndex = currentHoverIndex;
	currentHoverIndex++;
	
	allAccounts[currentHoverIndex] = new Array();
	var kind = SpringloadedDirectory.account.kind;
	var upAccount = null;
	
	// create new Account to go one level back up
	if('FTP' == kind)
		upAccount = new Account("##up##", SpringloadedDirectory.account.username, SpringloadedDirectory.account.host, SpringloadedDirectory.account.path, SpringloadedDirectory.account.httppath, SpringloadedDirectory.account.pass, "FTP");
	else if('Bluetooth' == kind)
		upAccount = new Account("##up##", "", "", "", "", "", "Bluetooth");
	
	allAccounts[currentHoverIndex].push(upAccount);
	
	// add new subdirectories to the allAccounts stack
	for (i = 0; i < subdirs.length; i++) {
		var thisDir = subdirs[i];
		
		// FTP
		if('FTP' == kind) {
			var oldPath = SpringloadedDirectory.account.path;
			if(oldPath.substr(oldPath.length-1, 1) != "/")
				oldPath += "/";
			
			allAccounts[currentHoverIndex].push(new Account(thisDir, SpringloadedDirectory.account.username, SpringloadedDirectory.account.host, oldPath + thisDir + "/", SpringloadedDirectory.account.httppath + thisDir + "/", SpringloadedDirectory.account.pass, "FTP"));
		}
		
		// Bluetooth
		else if('Bluetooth' == kind)
			allAccounts[currentHoverIndex].push(new Account(thisDir, "", "", "", "", "", "Bluetooth"));
		
	}
	
	// start the animation
	clearSpringloadedDirectory();
	setTimeout("startAnimateAccounts()", 10);
}

function bluetoothSubdirectoriesReceived(subdirs)		// hardcoded into the Plugin?
{
	subdirectoriesReceived(subdirs);
}


// stops the calling, shows a warning and cleans up
function SpringloadedDirectory_Timeout() {
	showFTPDirWarning(SpringloadedDirectory.account, 'timeout');
	SpringloadedDirectory_FullStop();
}


// stop the animation (re-apply the ftp-tag) and reset the vars
function clearSpringloadedDirectory() {
	SpringloadedDirectory_AnimationStop();
	SpringloadedDirectory = { account:null, div:null, animTimeout:null, animProgress:0 };
}


// animates the round thing while waiting for FTP dirs
function SpringloadedDirectory_Animate()
{
	if(++SpringloadedDirectory.animProgress == 12)
		SpringloadedDirectory.animProgress = 0;
	
	if(SpringloadedDirectory.div) {
		SpringloadedDirectory.div.style.backgroundImage = "url(Images/whiteProgress" + SpringloadedDirectory.animProgress + ".png)";
		SpringloadedDirectory.animTimeout = setTimeout("SpringloadedDirectory_Animate();", 80);
	}
}

// stops the round thing animation
function SpringloadedDirectory_AnimationStop(dont_reset_bg) {
	if(SpringloadedDirectory.animTimeout)
		clearTimeout(SpringloadedDirectory.animTimeout);
	SpringloadedDirectory.animTimeout = null
	
	// reset background
	if(SpringloadedDirectory.div && !dont_reset_bg) {
		var tag;
		switch(SpringloadedDirectory.account.kind) {
			case "FTP":			tag = "FTP_Tag.png";		break;
			case "Bluetooth":	tag = "Bluetooth_Tag.png";	break;
		}
		SpringloadedDirectory.div.style.backgroundImage = "url(Images/" + tag + ")";
	}
}




// terminates the subdir-call
function SpringloadedDirectory_FullStop() {
	if(window.widget){
		FTPUploadPlugin.cancelGettingListing();
	}
	
	if(0 != springFolderDelay)
		acceptSpringLoadedHover = true;
	
	clearSpringloadedDirectory();
}


// removes all front divs
function removeAllFrontAccounts() {
	var div = getObj('AccountFrontside_div');
	if(!div)
		return;
		
	// remove all accounts from the frontside
	while(null != div.firstChild) {
		var node = div.firstChild;
		div.removeChild(node);
	}
	
	// reset some variables
	accountsShowingOnFront = false;
	currentHoverIndex = 0;
	oldHoverIndex = -1;
	
	releaseiButton('front_accounts');
	removeAccountScroller();
}





/*
 *	Warnings inside the frontsideofwidgetcouldntthinkofabettername-thing
 */

var insideAccountWarning = { account:null, elem:null, step:0, interval:null };

// initiates the warning
function showFTPDirWarning(acc, errtype) {
	if(!acc || !acc.frontsideofwidgetcouldntthinkofabettername)
		return;
	
	stopFTPDirWarning();
	insideAccountWarning.account = acc;
	insideAccountWarning.step = 0;
	
	// create the div
	var errdiv = document.createElement('div');
	errdiv.setAttribute('class', 'genericError');
	
	// show the errors
	switch(errtype) {
		case "timeout":			errdiv.setAttribute("style", "background:url(Images/ftp_timeout.png) top left no-repeat;");			break;
		case "no_subdirs":		errdiv.setAttribute("style", "background:url(Images/ftp_no_subdir.png) top left no-repeat;");		break;
		case "7":				errdiv.setAttribute("style", "background:url(Images/ftp_7_no_connection.png) top left no-repeat;");		break;
		case "530":				errdiv.setAttribute("style", "background:url(Images/ftp_530_login_failed.png) top left no-repeat;");		break;
		case "550":				errdiv.setAttribute("style", "background:url(Images/ftp_550_no_permission.png) top left no-repeat;");		break;
		default:				errdiv.innerHTML = 'error' + (errtype ? ' ' + errtype : '');
	}
	
	acc.titleOfFront.appendChild(errdiv);
	insideAccountWarning.elem = errdiv;
	insideAccountWarning.interval = setInterval("animateFTPDirWarning()", 90);
}

// stop the currently running animation and clean up
function stopFTPDirWarning() {
	if(insideAccountWarning.interval)
		clearInterval(insideAccountWarning.interval);
	insideAccountWarning.interval = null
	
	if(insideAccountWarning.elem)
		insideAccountWarning.elem.parentNode.removeChild(insideAccountWarning.elem);
	insideAccountWarning.account = null;
	insideAccountWarning.elem = null;
	insideAccountWarning.step = 0;
}

// animation/removing of the warning
function animateFTPDirWarning() {
	if(insideAccountWarning.account) {
		insideAccountWarning.step++;
		
		// animate
		if(insideAccountWarning.step < 45) {
			var curr = eval((Math.sin((insideAccountWarning.step + Math.PI) / 2) + 1.3) / 2.3);
			insideAccountWarning.elem.style.opacity = curr;
		}
		
		// stop and clean up
		else {
			stopFTPDirWarning();
		}
	}
}






function dragover (event)
{
	if(currentHoverIndex && (!allAccounts[currentHoverIndex] || allAccounts[currentHoverIndex].length == 0)) {
		//alert('no accounts to dragover');
		return;
	}
	
	window.focus();
	hoversOverWidget = true;
	event.stopPropagation();
	event.preventDefault();
	
}

function dragleave (event)
{
	hoverAccount = null;
	hoversOverWidget = false;

	if (null != initiateListingTimer) window.clearTimeout(initiateListingTimer);
	initiateListingTimer = null;
	event.stopPropagation();
	event.preventDefault();
}


// looks if the Spacebar was pressed while the listing-timer is active
function keyPressed(event) {
	if(null == initiateListingTimer)
		return;
	
	var pressed = event.which;
	
	// modifiers
	if(event.shiftKey) {
		ACCOUNT_ANIM_TIME = 4000;
	}
	
	// keys pressed. 32 = Space
	if(32 == pressed) {
		window.clearTimeout(initiateListingTimer);
		initiateListingTimer = null;
		if (browsingBluetooth) getSpringloadedDirectories("Bluetooth");
		else getSpringloadedDirectories("FTP");
		// do the same thing if it's bluetooth
		event.stopPropagation();
		event.preventDefault();
	}
}



// ***********
// adds the scroller-stuff to scroll all those Accounts
var AccScroll = { interval:null, parentHeight:0, totalHeight:0, rate:40 };

function addAccountScroller() {
	removeAccountScroller();
	var cont = getObj('AccountFrontside_container');
	var div = getObj('AccountFrontside_div');
	
	
	// calculate current sizes
	var cont_curr = parseInt(getComputedValue('height', cont));
	var cont_total = parseInt(getComputedValue('height', div));
	if(cont_curr >= cont_total || cont_total < 15)
		return;
	
	AccScroll.parentHeight = cont_curr;
	AccScroll.totalHeight = cont_total;
	
	// create the scrollelements
	var scroll_up = document.createElement('div');
	scroll_up.setAttribute('id', 'AccountFrontside_moreUp');
	scroll_up.setAttribute('ondragover', "scrollAccountsUp()");
	scroll_up.setAttribute('ondragleave', "stopAccountScroll()");
	scroll_up.setAttribute('style', "display:none;");
	var scroll_down = document.createElement('div');
	scroll_down.setAttribute('id', 'AccountFrontside_moreDown');
	scroll_down.setAttribute('ondragover', "scrollAccountsDown()");
	scroll_down.setAttribute('ondragleave', "stopAccountScroll()");
	
	cont.insertBefore(scroll_up, div);
	cont.insertBefore(scroll_down, div);
}

function removeAccountScroller() {
	var cont = getObj('AccountFrontside_container');
	if(getObj('AccountFrontside_moreUp'))
		cont.removeChild(getObj('AccountFrontside_moreUp'));
	if(getObj('AccountFrontside_moreDown'))
		cont.removeChild(getObj('AccountFrontside_moreDown'));
}


function scrollAccountsUp() {
	if(null == AccScroll.interval) {
		getObj('AccountFrontside_moreUp').className = 'hover';
		clearInterval(AccScroll.interval);
		AccScroll.interval = setInterval("scrollNow(8)", AccScroll.rate);
	}
}

function scrollAccountsDown() {
	if(null == AccScroll.interval) {
		getObj('AccountFrontside_moreDown').className = 'hover';
		clearInterval(AccScroll.interval);
		AccScroll.interval = setInterval("scrollNow(-8)", AccScroll.rate);
	}
}

// sets style.top in order to scroll
function scrollNow(much) {
	var scrollDiv = getObj('AccountFrontside_div');
	
	if(isNaN(much))
		much = 8;
	
	var top = parseInt(getComputedValue('top', scrollDiv));
	var next = parseInt(1* top + much);
	
	// we are at the top position
	if(next >= 0) {
		next = 0;
		getObj('AccountFrontside_moreUp').setAttribute('style', "display:none;");
		getObj('AccountFrontside_moreDown').removeAttribute('style');
		if(null != AccScroll.interval)
			clearInterval(AccScroll.interval);
		AccScroll.interval = null;
	}
	
	// we are at the bottom
	else if(next < (AccScroll.parentHeight - AccScroll.totalHeight)) {
		next = (AccScroll.parentHeight - AccScroll.totalHeight);
		getObj('AccountFrontside_moreUp').removeAttribute('style');
		getObj('AccountFrontside_moreDown').setAttribute('style', "display:none;");
		if(null != AccScroll.interval)
			clearInterval(AccScroll.interval);
		AccScroll.interval = null;
	}
	
	// somewhere in the middle
	else {
		getObj('AccountFrontside_moreUp').removeAttribute('style');
		getObj('AccountFrontside_moreDown').removeAttribute('style');
	}
	
	// do it!
	scrollDiv.style.top = next + 'px';
}

function stopAccountScroll() {
	getObj('AccountFrontside_moreUp').removeAttribute('class');
	getObj('AccountFrontside_moreDown').removeAttribute('class');
	
	if(null != AccScroll.interval)
		clearInterval(AccScroll.interval);
	AccScroll.interval = null;
}


function getAccountByDiv(div)
{
	if(allAccounts && allAccounts.length > 0) {
		for (i = 0; i < allAccounts.length; i++)
		{
			for (j = 0; j < allAccounts[i].length; j++)
			{
				if (div == allAccounts[i][j].div) return allAccounts[i][j];
			}
		}
	}
	alert("getAccountbyDiv returned null!");
	return null;
}

function getAccountByFrontside(div)
{
	if(allAccounts && allAccounts.length > 0) {
		for (i = 0; i < allAccounts.length; i++)
		{
			if(allAccounts[i] && allAccounts[i].length > 0) {
				for (j = 0; j < allAccounts[i].length; j++)
				{
					if (div == allAccounts[i][j].frontsideofwidgetcouldntthinkofabettername) return allAccounts[i][j];
				}
			}
		}
	}
	alert("getAccountByFrontside returned null!");
	return null;
}







/*************************
 *  The Account - Class  *
 *************************/

function Account(not, name, host, path, httppath, pass, kind) {
	if(!(this instanceof Account))
		return new Account(not, name, host, path, httppath, pass, kind);
	
	// the properties
	this.notation = not ? not.replace(/\n/, "<br />") : 'Account';
	this.username = name ? name : '';
	this.host = host ? host : '';
	this.path = path ? path : '';
	this.httppath = httppath ? httppath : '';
	this.pass = pass ? pass : '';
	
	this.kind = kind ? kind : 'FTP';
	this.is_MoveDirUpChooser = ("##up##" == this.notation);
	
	// account representation in the prefs (FTP only)
	if(("FTP" == this.kind) && (currentHoverIndex == 0)) {
		this.parent = getObj('accountList');
		this.div = document.createElement('div');
		this.div.setAttribute('class', 'Account');
		this.div.setAttribute('onclick', "getAccountByDiv(this).loadAccountDetails()");
		this.div.innerText = this.notation;
		
		var delknob = document.createElement('img');
		delknob.setAttribute('class', 'delknob');
		delknob.setAttribute('src', 'Images/cross.png');
		delknob.setAttribute('onclick', "getAccountByDiv(this.parentNode).deleteAccount(); event.stopPropagation();");
		this.div.appendChild(delknob);
		if(this.parent)
			this.parent.appendChild(this.div);
	}
	
	// frontside account representation
	this.frontsideofwidgetcouldntthinkofabettername = document.createElement('div');
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside');
	if(this.is_MoveDirUpChooser) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('style', 'background-image:none');
	}
	else if("Bonjour" == this.kind) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('style', 'background-image:url(Images/Bonjour_Tag.png)');
	}
	else if("Bluetooth" == this.kind) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('style', 'background-image:url(Images/Bluetooth_Tag.png)');
	}
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondrop', "getAccountByFrontside(this).selectUploadAccount(event)");
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondragover', "getAccountByFrontside(this).dragenter(event)");
	this.frontsideofwidgetcouldntthinkofabettername.setAttribute('ondragleave', "getAccountByFrontside(this).dragleave(event)");
	this.titleOfFront = document.createElement('p');
	this.frontsideofwidgetcouldntthinkofabettername.appendChild(this.titleOfFront);
	switch(this.kind) {
		case "FTP":			this.hoverclass = 'hover_ftp';			break;
		case "Bonjour":		this.hoverclass = 'hover_bonjour';		break;
		case "Bluetooth":	this.hoverclass = 'hover_bluetooth';	break;
	}
	
	
	/******/
	// methods
	this.setNotation = function(not) {
		this.notation = not ? not.replace(/\n/, "<br />") : 'Account';
		
		this.createPrefRepresentation(this.notation);
		
		if(this.frontsideofwidgetcouldntthinkofabettername) {
			if(this.is_MoveDirUpChooser) {
				this.titleOfFront.innerHTML = ("Bluetooth" == this.kind) ? "<img src=\"./Images/moveDirUp_bluetooth.png\" alt=\".. (up)\" />" : "<img src=\"./Images/moveDirUp_ftp.png\" alt=\".. (up)\" />";
			}
			else {
				this.titleOfFront.innerHTML = this.notation;
			}
		}
	}
	
	this.setUsername = function(name) {
		this.username = name;
	}
	
	this.setPassword = function(pass) {
		this.pass = pass;
	}
	
	this.setPath = function(path) {
		this.path = path;
	}
	
	this.setHTTPPath = function(httppath) {
		if(httppath && httppath.length > 0 && "/" != httppath.substr(httppath.length-1, 1))
			httppath += "/";
		this.httppath = httppath ? httppath : null;
	}
	
	// creates the account-representation on the backside within "Accounts"
	this.createPrefRepresentation = function(not) {
		if("FTP" != this.kind)
			return;
		
		this.notation = not ? not : 'Account';
		
		if(this.div) {
			this.div.innerText = this.notation;
			var delknob = document.createElement('img');
			delknob.setAttribute('class', 'delknob');
			delknob.setAttribute('src', 'Images/cross.png');
			delknob.setAttribute('onclick', "getAccountByDiv(this.parentNode).deleteAccount(); event.stopPropagation();");
			this.div.appendChild(delknob);
		}
	}
	
	this.selectUploadAccount = function(event) {
		uploadAccount = this;
	}
	
	// Drag events
	this.dragenter = function(event) {
		if(this !== hoverAccount) {
			this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside ' + this.hoverclass);
			
			hoversOverAccount = true;
			hoversOverWidget = true;
			
			if (acceptSpringLoadedHover)
			{
				//alert("timer launched");
				hoverAccount = this;
				browsingBluetooth = false;
				if (null != initiateListingTimer) window.clearTimeout(initiateListingTimer);
				if ("FTP" == this.kind) initiateListingTimer = window.setTimeout("getSpringloadedDirectories('FTP');", 1000 * springFolderDelay);
				else 
				if ("Bluetooth" == this.kind && (currentHoverIndex == 0 ? FTPUploadPlugin.deviceSupportsFileTransfer(this.notation) : true))
				{
					browsingBluetooth = true;
					initiateListingTimer = window.setTimeout("getSpringloadedDirectories('Bluetooth');", 1000 * springFolderDelay);
				}
			}
		}
	}
	
	this.dragleave = function(event) {
		this.frontsideofwidgetcouldntthinkofabettername.setAttribute('class', 'AccountFrontside');
		hoversOverAccount = false;

		if (null != initiateListingTimer) window.clearTimeout(initiateListingTimer);
		initiateListingTimer = null;
		event.stopPropagation();
		event.preventDefault();
		
		hoverAccount = null;
	}
	
	// used for the sheet on the backside
	this.loadAccountDetails = function() {
		loadedAccount = this;
		showAccountForm();
	}
	
	this.saveValues = function() {
		if(window.widget) {
		}
	}
	
	this.saveNewValues = function() {
		var form = document.forms['prefform'];
		this.setNotation(form.acc_notation.value);
		this.setUsername(form.acc_user.value);
		this.setPassword(form.acc_pass.value);
		this.host = form.acc_host.value;
		this.setPath(form.acc_path.value);
		this.setHTTPPath(form.acc_httppath.value);
		
		this.saveValues();
	}
	
	this.getArrayIndex = function() {
		//alert("getArrayIndex called");
		var index = -1;
		if(allAccounts[currentHoverIndex].length > 0) {
			for(var i = 0; i < allAccounts[currentHoverIndex].length; i++) {
				if(this == allAccounts[currentHoverIndex][i]) {
					index = i;
					break;
				}
			}
		}
		return index;
	}
	
	
	// returns the remote path
	this.getRemotePath = function() {
		var result = "";
		var host = this.host;
		var path = this.path;
		
		if (host.indexOf("ftp://") == 0) result = host;
		else result = "ftp://" + host
		
		if (result.substr(result.length-1, 1) != "/") result += "/";
		
		if (path == "/") path = "";
		
		if (path.length > 0)
		{
			if (path.substr(0,1) == "/") path = path.substr(1, path.length-1);
			result += path;
		}
	
		if (result.substr(result.length-1, 1) != "/") result += "/";
		
		return result;
	}
	
	
	this.deleteAccount = function() {
		var index = this.getArrayIndex();
		
		// delete instance
		try {
			this.parent.removeChild(this.div);
			
			// show poof
			var event = window.event;
			showPoof(event.x, event.y);
		}
		catch(exc) {  }
		
		// delete from array
		if(-1 < index) {
			allAccounts[currentHoverIndex].splice(index, 1);
			return true;
		}
		else
			return false;
	}
	
	this.animation = { startLeft:0, startTop:0, startWidth:0, startHeight:0, finalLeft:0, finalTop:0, finalWidth:0, finalHeight:0, startTransparency:0, finalTransparency:0 };

	this.animateAt = function(delta)
	{
		var height = (delta * this.animation.finalHeight) + ((1-delta) * this.animation.startHeight);
		this.frontsideofwidgetcouldntthinkofabettername.style.left = (delta * this.animation.finalLeft) + ((1-delta) * this.animation.startLeft);
		this.frontsideofwidgetcouldntthinkofabettername.style.top = (delta * this.animation.finalTop) + ((1-delta) * this.animation.startTop);
		this.frontsideofwidgetcouldntthinkofabettername.style.width = (delta * this.animation.finalWidth) + ((1-delta) * this.animation.startWidth);
		this.frontsideofwidgetcouldntthinkofabettername.style.height = height + 'px';
		this.frontsideofwidgetcouldntthinkofabettername.style.opacity = (delta * this.animation.finalTransparency) + ((1-delta) * this.animation.startTransparency);
	}
	
	this.setNotation(not);
	if(this.kind == "FTP")
		this.saveValues();
	
	return this;
}




function bonjourDownloadTargetChanged()
{
	var opt = getObj("bonjourDownloadTarget");
	var optval = opt.options[opt.selectedIndex].value;
	FTPUploadPlugin.setBonjourDownloadTarget(optval);
	if (window.widget) widget.setPreferenceForKey(optval, "bonjourDownloadTarget");
}

function uploadSoundChanged(dont_beep)
{
	var opt = getObj("uploadSound");
	var optval = opt.options[opt.selectedIndex].value;
	
	if (window.widget) widget.setPreferenceForKey(optval, "uploadSound");
	
	if(getObj("currentAlertSoundEmbed")) {
		getObj("soundPlayerDiv").removeChild(getObj("currentAlertSoundEmbed"));
	}
	
	// default alert-sound chosen; play it
	if("System Alarm Sound" == optval) {
		FTPUploadPlugin.beep();
	}
	
	// play the chosen alarm-sound
	else if('' != optval) {
		var soundPlayer = document.createElement("embed");
		soundPlayer.setAttribute("id", "currentAlertSoundEmbed");
		soundPlayer.setAttribute("src", optval);
		soundPlayer.setAttribute("autostart", "false");
		soundPlayer.setAttribute("hidden", "true");
		soundPlayer.setAttribute("enablejavascript", true);
		getObj("soundPlayerDiv").appendChild(soundPlayer);
		
		soundPlayer.Play();
	}
	
	// no sound played; hide the play-button
	try {
		getObj('uploadSoundPlayNow').style.display = ('' == optval) ? 'none' : 'inline';
	}
	catch(exc) {  }
}

function playUploadSound() {
	var opt = getObj("uploadSound");
	var optval = opt ? opt.options[opt.selectedIndex].value : '';
	
	
	// default alert-sound chosen; play it
	if("System Alarm Sound" == optval) {
		if(window.widget) {
			FTPUploadPlugin.beep();
		}
	}
	
	// play the chosen alarm-sound
	else if('' != optval && getObj("currentAlertSoundEmbed")) {
		getObj("currentAlertSoundEmbed").Play();
	}
}



// keeps track of who blocks the i-button
function blockiButton(obj) {
	iButtonBlockArr[obj] = true;
}

function releaseiButton(obj) {
	iButtonBlockArr[obj] = false;
}

function iButtonBlocked() {
	for(var p in iButtonBlockArr) {
		if(true == iButtonBlockArr[p]) {
			return true;
		}
	}
	
	return false;
}




/*
 **************
 *  by Apple  *
 **************
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(iButtonBlocked()) {
		mouseexit(event);
		return;
	}
	
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = getObj('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = getObj('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	if(iButtonBlocked())
		return;
	
	getObj("fliprollie").style.display = "block";
}

function exitflip(event) {
	getObj("fliprollie").style.display = "none";
}


